package de.twenty11.skysail.common.converter;

import java.io.File;
import java.io.IOException;

import org.codehaus.jackson.JsonNode;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.node.TextNode;
import org.restlet.ext.jackson.JacksonConverter;
import org.restlet.representation.Representation;
import org.restlet.representation.StringRepresentation;
import org.restlet.representation.Variant;
import org.restlet.resource.Resource;

import de.twenty11.skysail.common.responses.Response;

public class BrowserJacksonConverter extends JacksonConverter {

    private ObjectMapper m = new ObjectMapper();

    @Override
    public Representation toRepresentation(Object source, Variant target, Resource resource) {
        Representation representation = super.toRepresentation(source, target, resource);
        try {
            return new StringRepresentation(jsonToHtml(representation.getText()));
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return representation;
    }

    public String jsonToHtml(String json) {

        json = "{ \"name\" : { \"first\" : \"Joe\", \"last\" : \"Sixpack\" }, \"gender\" : \"MALE\", \"verified\" : false, \"userImage\" : \"Rm9vYmFyIQ==\" }";

        JsonNode rootNode;
        try {
            rootNode = m.readValue(json, JsonNode.class);

            handleNode(rootNode);

            m.writeValue(new File("user-modified.json"), rootNode);
        } catch (Exception e) {
            e.printStackTrace();
        }

        // JsonNode rootNode = m.readTree(new File("user.json"));
        // ensure that "last name" isn't "Xmler"; if is, change to "Jsoner"
        // JsonNode nameNode = rootNode.path("name");
        // String lastName = nameNode.path("last").getTextValue().
        // if ("xmler".equalsIgnoreCase(lastName)) {
        // ((ObjectNode)nameNode).put("last", "Jsoner");
        // }
        // and write it out:

        json = json.replace("{", "{<br>\n");
        json = json.replace("}", "}<br>\n");
        json = json.replace(",", ",<br>\n");

        StringBuffer sb = new StringBuffer("<!DOCTYPE html>\n")
                .append("<html><head><title>BrowserJacksonPresentation</title>\n")
                .append("<link rel=\"stylesheet\" type=\"text/css\" href=\"chrome://jsonview/content/default.css\">\n")
                .append("<script type=\"text/javascript\" src=\"chrome://jsonview/content/default.js\"></script>")
                .append("</head>\n<body>\n").append(json).append("\n</body>\n</html>");
        return sb.toString();
    }

    private void handleNode(JsonNode rootNode) {
        for (JsonNode jsonNode : rootNode) {
            // if (jsonNode instanceof ObjectNode) {
            // System.out.println(((ObjectNode) jsonNode).() + ": " + jsonNode.asText());
            // } else
            if (jsonNode instanceof TextNode) {
                System.out.println(((TextNode) jsonNode).asToken() + ": " + jsonNode.asText());
            } else {
                System.out.println(jsonNode.getClass().getSimpleName() + ": " + jsonNode.asText());
            }
            handleNode(jsonNode);
        }
    }

    @Override
    public float score(Object source, Variant target, Resource resource) {
        float result = -1.0F;

        if (source instanceof Response<?>) {
            result = 1.0F;
        } else {
            result = 0.5F;
        }

        return result;
    }

}
